## org.plovr
Enum ConfigOption

    java.lang.Object
      java.lang.Enum<ConfigOption>
          org.plovr.ConfigOption

All Implemented Interfaces:
  Serializable, Comparable<ConfigOption>

    public enum ConfigOption

extends Enum<ConfigOption>

Enum Constant Summary
`AMBIGUATE_PROPERTIES`
`CLOSURE_LIBRARY`
`COMPILATION_MODE`
`CSS_ALLOWED_NON_STANDARD_FUNCTIONS`
`CSS_ALLOWED_UNRECOGNIZED_PROPERTIES`
`CSS_DEFINES`
`CSS_GSS_FUNCTION_MAP_PROVIDER`
`CSS_INPUTS` CSS OPTIONS
`CSS_OUTPUT_FILE`
`CUSTOM_EXTERNS_ONLY`
`CUSTOM_PASSES`
`DEBUG`
`DEFINE`
`DIAGNOSTIC_GROUPS`
`DISAMBIGUATE_PROPERTIES`
`EXCLUDE_CLOSURE_LIBRARY`
`EXPERIMENTAL_COMPILER_OPTIONS`
`EXPORT_TEST_FUNCTIONS`
`EXTERNS`
`FINGERPRINT`
`GLOBAL_SCOPE_NAME`
`ID`
`ID_GENERATORS`
`INHERITS`
`INPUTS`
`JSDOC_HTML_OUTPUT_PATH`
`MODULE_INFO_PATH` This option is used to write the plovr module info JS into a separate file instead of prepending it to the root module.
`MODULE_OUTPUT_PATH`
`MODULE_PRODUCTION_URI`
`MODULES`
`NAME_SUFFIXES_TO_STRIP`
`OUTPUT_CHARSET`
`OUTPUT_FILE`
`OUTPUT_WRAPPER`
`PATHS`
`PRETTY_PRINT`
`PRINT_INPUT_DELIMITER`
`PROPERTY_MAP_INPUT_FILE`
`PROPERTY_MAP_OUTPUT_FILE`
`SOY_FUNCTION_PLUGINS`
`TEST_DRIVERS`
`TEST_EXCLUDES`
`TEST_TEMPLATE`
`TREAT_WARNINGS_AS_ERRORS`
`TYPE_PREFIXES_TO_STRIP`
`VARIABLE_MAP_INPUT_FILE`
`VARIABLE_MAP_OUTPUT_FILE`
`WARNING_LEVEL`

Method Summary
`String` `getName()`
`boolean` `reset(Config.Builder builder)` Reset the values associated with this option in the specified builder.
`void` `update(Config.Builder builder, JsonElement json)`
`boolean` `update(Config.Builder builder, QueryData data)`
`static ConfigOption` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static ConfigOption[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### ID

    public static final ConfigOption ID

### INPUTS

    public static final ConfigOption INPUTS

### PATHS

    public static final ConfigOption PATHS

### EXTERNS

    public static final ConfigOption EXTERNS

### CUSTOM_EXTERNS_ONLY

    public static final ConfigOption CUSTOM_EXTERNS_ONLY

### CLOSURE_LIBRARY

    public static final ConfigOption CLOSURE_LIBRARY

### EXCLUDE_CLOSURE_LIBRARY

    public static final ConfigOption EXCLUDE_CLOSURE_LIBRARY

### COMPILATION_MODE

    public static final ConfigOption COMPILATION_MODE

### WARNING_LEVEL

    public static final ConfigOption WARNING_LEVEL

### INHERITS

    public static final ConfigOption INHERITS

### DEBUG

    public static final ConfigOption DEBUG

### PRETTY_PRINT

    public static final ConfigOption PRETTY_PRINT

### PRINT_INPUT_DELIMITER

    public static final ConfigOption PRINT_INPUT_DELIMITER

### OUTPUT_FILE

    public static final ConfigOption OUTPUT_FILE

### OUTPUT_WRAPPER

    public static final ConfigOption OUTPUT_WRAPPER

### OUTPUT_CHARSET

    public static final ConfigOption OUTPUT_CHARSET

### FINGERPRINT

    public static final ConfigOption FINGERPRINT

### MODULES

    public static final ConfigOption MODULES

### MODULE_OUTPUT_PATH

    public static final ConfigOption MODULE_OUTPUT_PATH

### MODULE_PRODUCTION_URI

    public static final ConfigOption MODULE_PRODUCTION_URI

### MODULE_INFO_PATH

    public static final ConfigOption MODULE_INFO_PATH

  This option is used to write the plovr module info JS into a separate file instead of prepending it to the root module. Prepending the JS causes the source map to be several lines off in the root module, so doing this avoids that issue.

### GLOBAL_SCOPE_NAME

    public static final ConfigOption GLOBAL_SCOPE_NAME

### DEFINE

    public static final ConfigOption DEFINE

### DIAGNOSTIC_GROUPS

    public static final ConfigOption DIAGNOSTIC_GROUPS

### TREAT_WARNINGS_AS_ERRORS

    public static final ConfigOption TREAT_WARNINGS_AS_ERRORS

### EXPORT_TEST_FUNCTIONS

    public static final ConfigOption EXPORT_TEST_FUNCTIONS

### NAME_SUFFIXES_TO_STRIP

    public static final ConfigOption NAME_SUFFIXES_TO_STRIP

### TYPE_PREFIXES_TO_STRIP

    public static final ConfigOption TYPE_PREFIXES_TO_STRIP

### ID_GENERATORS

    public static final ConfigOption ID_GENERATORS

### AMBIGUATE_PROPERTIES

    public static final ConfigOption AMBIGUATE_PROPERTIES

### DISAMBIGUATE_PROPERTIES

    public static final ConfigOption DISAMBIGUATE_PROPERTIES

### EXPERIMENTAL_COMPILER_OPTIONS

    public static final ConfigOption EXPERIMENTAL_COMPILER_OPTIONS

### CUSTOM_PASSES

    public static final ConfigOption CUSTOM_PASSES

### SOY_FUNCTION_PLUGINS

    public static final ConfigOption SOY_FUNCTION_PLUGINS

### JSDOC_HTML_OUTPUT_PATH

    public static final ConfigOption JSDOC_HTML_OUTPUT_PATH

### VARIABLE_MAP_INPUT_FILE

    public static final ConfigOption VARIABLE_MAP_INPUT_FILE

### VARIABLE_MAP_OUTPUT_FILE

    public static final ConfigOption VARIABLE_MAP_OUTPUT_FILE

### PROPERTY_MAP_INPUT_FILE

    public static final ConfigOption PROPERTY_MAP_INPUT_FILE

### PROPERTY_MAP_OUTPUT_FILE

    public static final ConfigOption PROPERTY_MAP_OUTPUT_FILE

### TEST_DRIVERS

    public static final ConfigOption TEST_DRIVERS

### TEST_TEMPLATE

    public static final ConfigOption TEST_TEMPLATE

### TEST_EXCLUDES

    public static final ConfigOption TEST_EXCLUDES

### CSS_INPUTS

    public static final ConfigOption CSS_INPUTS

  CSS OPTIONS

### CSS_DEFINES

    public static final ConfigOption CSS_DEFINES

### CSS_ALLOWED_UNRECOGNIZED_PROPERTIES

    public static final ConfigOption CSS_ALLOWED_UNRECOGNIZED_PROPERTIES

### CSS_ALLOWED_NON_STANDARD_FUNCTIONS

    public static final ConfigOption CSS_ALLOWED_NON_STANDARD_FUNCTIONS

### CSS_GSS_FUNCTION_MAP_PROVIDER

    public static final ConfigOption CSS_GSS_FUNCTION_MAP_PROVIDER

### CSS_OUTPUT_FILE

    public static final ConfigOption CSS_OUTPUT_FILE

Method Detail

### values

    public static ConfigOption[] values()

  Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

      for (ConfigOption c : ConfigOption.values())
          System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they are declared

### valueOf

    public static ConfigOption valueOf(String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `IllegalArgumentException` - if this enum type has no constant with the specified name
    `NullPointerException` - if the argument is null

### getName

    public String getName()

### update

    public void update(Config.Builder builder,
                       JsonElement json)

### update

    public boolean update(Config.Builder builder,
                          QueryData data)

  Returns:
    true to indicate that the parameter was processed

### reset

    public boolean reset(Config.Builder builder)

  Reset the values associated with this option in the specified builder. This is important for config inheritance to ensure that a sub-config completely overrides an option from its parent config.

  Parameters:
    `builder` -